#ifndef __THREAD_H_CSH__
#define __THREAD_H_CSH__

#include <windows.h>
#include <process.h>
#include <stdarg.h>


class CThread
{
public:
	CThread(UINT nStackSize = 0, UINT nPriority = THREAD_PRIORITY_NORMAL);
	virtual ~CThread();

protected:
	DWORD m_dwThreadID;		//  ID
	HANDLE m_hThread;		//  ڵ
	int m_nStackSize;		//   
	int m_nPriority;		//  켱

/*	//  Ŭ
	class Exception
	{
	public:
		int exNum;
		char* exStr;
		Exception(int num = -1);
		Exception(const char* str);
		~Exception();
	};
*/

private:		//   
	static unsigned __stdcall __THREAD_ENTRY_POINT(void*);

public:
	void Start();
	BOOL Stop();

	// 尡 ɶ ٸ.
	//  尡  ð  ʾ  带 Ų.
	BOOL WaitForTermination(DWORD dwMilliSeconds = INFINITE);
	
	//  켱
	void SetPriority(int nPriority);
	int GetPriority() const;
		
	
public:
	// 峻 Ǵ Լ( ۼǴ ڵ̴)
	virtual int Run() = 0;

	// Լ  ߻ ó Լ
	//virtual void processException(Exception);
};

#endif // #ifndef __THREAD_H_CSH__