#ifndef __WORKER_H_CSH__
#define __WORKER_H_CSH__

#include <iostream>
#include <winsock2.h>
#include "thread.h"
#include "usercontext.h"
#include "share.h"

class CServer;

class CWorker : public CThread  
{
public:
	CWorker(CServer& rServer);
	virtual ~CWorker();

private:
	BOOL m_bRun;				// Ŀ  
	CServer& m_rServer;			//  ۷
	CRITICAL_SECTION m_csDb;	// MS ACCESS ͺ̽ THREAD_SAFE ʱ⶧
								// ũƼ  Ͽ ȭѴ.

private:
	// ú ̺Ʈ ó ڵ鷯 Լ
	BOOL RecvCompleteEvent(CUserContext* pUserContext, DWORD dwBytesTransferred);
	// Send Ϸ Ŷ ó ڵ鷯 Լ
	BOOL SendCompleteEvent(CUserContext* pUserContext, DWORD dwBytesTransferred);
	// Recv, Send Ϸ   ó ڵ鷯 Լ
	BOOL OtherCompleteEvent(CUserContext* pUserContext, DWORD dwBytesTransferred);

public:
	// Ŀ  Լ
	int Run();

	// Recv û
	BOOL RecvPost(CUserContext* pUserContext);
	// Send û
	BOOL SendPost(CUserContext* pUserContext);

};


#endif // #ifndef __WORKER_H_CSH__