#ifndef __DBMANAGER_H_CSH__
#define __DBMANAGER_H_CSH__

#include <sql.h>
#include <sqlext.h>
#include <stdarg.h>
#include <iostream>


class CDBManager
{
public:
	// ִ ÷, BLOB  , NULL ʵ尪
	enum { MAXCOL=20, CQUERYNULL=-100, CQUERYEOF=-101, 
		CQUERYNOCOL=-102, CQUERYERROR=-103 };

public:
	CDBManager();
	~CDBManager();

private:
	SQLHENV m_hEnv;							// ȯ ڵ
	SQLHDBC m_hDbc;							//  ڵ
	SQLRETURN m_Ret;						//   SQL 
	char m_BindCol[MAXCOL][255];				// ε ÷ 

public:
	SQLINTEGER m_AffectCount;				//  ڵ 
	SQLHSTMT m_hStmt;						//  ڵ.    Ƿ public 
	SQLSMALLINT m_nCol;						// ÷ 
	SQLCHAR m_ColName[MAXCOL][50];			// ÷ ̸
	SQLINTEGER m_InfoCol[MAXCOL];			// ÷ / 

private:
	// ÷ ̸κ ȣ ãش.
	int FindCol(char *name);				

public:
	//   
	void PrintDiag();						
	//  ҽ Ѵ.
	BOOL Connect(char *ConStr, char *UID=NULL, char *PWD=NULL);	
	//  ҽ  Ѵ
	void Disconnect();
	// SQL Ѵ.
	BOOL Exec(LPCTSTR szSQL);				
	// SQL ϰ ù° ÷  
	int ExecGetInt(LPCTSTR szSQL);			
	// SQL ϰ ù° ÷ ڿ 
	void ExecGetStr(LPCTSTR szSQL, char *buf);		
	//   
	SQLRETURN Fetch();						
	// Ŀ    ε
	void Clear();							
	//  ÷ б
	int GetInt(int nCol);					
	//  ÷ б
	int GetInt(char *sCol);					
	// ڿ ÷ б
	void GetStr(int nCol, char *buf);		
	// ڿ ÷ б
	void GetStr(char *sCol, char *buf);
	//  ڵ鷯
	void ErrorHandler(const char* strErr, ...);
};

#endif // #ifndef __DBMANAGER_H_CSH__