#ifndef __PACKET_H_CSH__
#define __PACKET_H_CSH__

#include <winsock2.h>
#include "share.h"

enum
{
	CONNECTION,
	DISCONNECTION,
	VER,
	SIGNUP,
	UNSIGN,
	LOGON,
    LOGOUT,
	MODUSER,
	PING,
	USERLIST,
	CHANGE_STATUS,
	NOTIFY_STATUS,
	CHANGE_NICK,
	NOTIFY_NICK,
	ADDFRIEND,
	DELFRIEND,
	BANFRIEND,
	SEND_MSG,
	NOTIFY_MSG
};

enum
{
	OK,		
	SERVER_FULL,
	CONNECT_ERROR,
	INVALID_VER,
	INVALID_DATA,
	INVALID_PACKET_ID,
	NO_USER,
	INVALID_PASSWD,
	USER_ID_EXIST,
	BANNED
};


class CPacket
{
public:
	CPacket();
	
public:
	union
	{
		char szBuffer[BUFFER_SIZE];
		struct
		{
			DWORD id;		// Ŷ ȣ
			WORD command;	// Ŷ޽  
			WORD subcode;	// ɿ  , Ȥ 
			WORD length;	//     
			DWORD uniqueid;	// ȸ ȣ
			char type;		//  
							// 0 :  
							// 1~127 :  Ŷ 
			char packetnum; // Ŷ Ÿ 0 ƴҰ, Ŷ ȣ
			char data[PACKET_DATA_SIZE];		// 
		};
	};
};


#endif // #ifndef __PACKET_H_CSH__